/* Generated by wayland-scanner 1.22.0 */

#ifndef GAMESCOPE_XWAYLAND_CLIENT_PROTOCOL_H
#define GAMESCOPE_XWAYLAND_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_gamescope_xwayland The gamescope_xwayland protocol
 * gamescope-specific xwayland protocol
 *
 * @section page_desc_gamescope_xwayland Description
 *
 * This is a private Gamescope protocol. Regular Wayland clients must not use
 * it.
 *
 * @section page_ifaces_gamescope_xwayland Interfaces
 * - @subpage page_iface_gamescope_xwayland - 
 * @section page_copyright_gamescope_xwayland Copyright
 * <pre>
 *
 * Copyright © 2021 Valve Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct gamescope_xwayland;
struct wl_surface;

#ifndef GAMESCOPE_XWAYLAND_INTERFACE
#define GAMESCOPE_XWAYLAND_INTERFACE
/**
 * @page page_iface_gamescope_xwayland gamescope_xwayland
 * @section page_iface_gamescope_xwayland_api API
 * See @ref iface_gamescope_xwayland.
 */
/**
 * @defgroup iface_gamescope_xwayland The gamescope_xwayland interface
 */
extern const struct wl_interface gamescope_xwayland_interface;
#endif

#define GAMESCOPE_XWAYLAND_DESTROY 0
#define GAMESCOPE_XWAYLAND_OVERRIDE_WINDOW_CONTENT 1
#define GAMESCOPE_XWAYLAND_OVERRIDE_WINDOW_CONTENT2 2
#define GAMESCOPE_XWAYLAND_SWAPCHAIN_FEEDBACK 3
#define GAMESCOPE_XWAYLAND_SET_HDR_METADATA 4


/**
 * @ingroup iface_gamescope_xwayland
 */
#define GAMESCOPE_XWAYLAND_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_gamescope_xwayland
 */
#define GAMESCOPE_XWAYLAND_OVERRIDE_WINDOW_CONTENT_SINCE_VERSION 1
/**
 * @ingroup iface_gamescope_xwayland
 */
#define GAMESCOPE_XWAYLAND_OVERRIDE_WINDOW_CONTENT2_SINCE_VERSION 2
/**
 * @ingroup iface_gamescope_xwayland
 */
#define GAMESCOPE_XWAYLAND_SWAPCHAIN_FEEDBACK_SINCE_VERSION 2
/**
 * @ingroup iface_gamescope_xwayland
 */
#define GAMESCOPE_XWAYLAND_SET_HDR_METADATA_SINCE_VERSION 2

/** @ingroup iface_gamescope_xwayland */
static inline void
gamescope_xwayland_set_user_data(struct gamescope_xwayland *gamescope_xwayland, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) gamescope_xwayland, user_data);
}

/** @ingroup iface_gamescope_xwayland */
static inline void *
gamescope_xwayland_get_user_data(struct gamescope_xwayland *gamescope_xwayland)
{
	return wl_proxy_get_user_data((struct wl_proxy *) gamescope_xwayland);
}

static inline uint32_t
gamescope_xwayland_get_version(struct gamescope_xwayland *gamescope_xwayland)
{
	return wl_proxy_get_version((struct wl_proxy *) gamescope_xwayland);
}

/**
 * @ingroup iface_gamescope_xwayland
 */
static inline void
gamescope_xwayland_destroy(struct gamescope_xwayland *gamescope_xwayland)
{
	wl_proxy_marshal_flags((struct wl_proxy *) gamescope_xwayland,
			 GAMESCOPE_XWAYLAND_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) gamescope_xwayland), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_gamescope_xwayland
 *
 * See override_window_content2.
 */
static inline void
gamescope_xwayland_override_window_content(struct gamescope_xwayland *gamescope_xwayland, struct wl_surface *surface, uint32_t x11_window)
{
	wl_proxy_marshal_flags((struct wl_proxy *) gamescope_xwayland,
			 GAMESCOPE_XWAYLAND_OVERRIDE_WINDOW_CONTENT, NULL, wl_proxy_get_version((struct wl_proxy *) gamescope_xwayland), 0, surface, x11_window);
}

/**
 * @ingroup iface_gamescope_xwayland
 *
 * Xwayland creates a wl_surface for each X11 window. It sends a
 * WL_SURFACE_ID client message to indicate the mapping between the X11
 * windows and the wl_surface objects.
 *
 * This request overrides this mapping for a given X11 window, allowing an
 * X11 client to submit buffers via the Wayland protocol. The override
 * only affects buffer submission. Everything else (e.g. input events)
 * still uses Xwayland's WL_SURFACE_ID.
 *
 * x11_server is gotten by the GAMESCOPE_XWAYLAND_SERVER_ID property on the
 * root window of the associated server.
 */
static inline void
gamescope_xwayland_override_window_content2(struct gamescope_xwayland *gamescope_xwayland, struct wl_surface *surface, uint32_t gamescope_xwayland_server_id, uint32_t x11_window)
{
	wl_proxy_marshal_flags((struct wl_proxy *) gamescope_xwayland,
			 GAMESCOPE_XWAYLAND_OVERRIDE_WINDOW_CONTENT2, NULL, wl_proxy_get_version((struct wl_proxy *) gamescope_xwayland), 0, surface, gamescope_xwayland_server_id, x11_window);
}

/**
 * @ingroup iface_gamescope_xwayland
 *
 * Provide swapchain feedback to the compositor.
 *
 * This is what the useless tearing protocol should have been.
 * Absolutely not enough information in the final protocol to do what we want for SteamOS --
 * which is have the Allow Tearing toggle apply to *both* Mailbox + Immediate and NOT fifo,
 * essentially acting as an override for tearing on/off for games.
 * The upstream protocol is very useless for our usecase here.
 *
 * Provides image count ahead of time instead of needing to try and calculate it from
 * an initial stall if we are doing low latency.
 *
 * Provides colorspace info for us to do HDR for both HDR10 PQ and scRGB.
 * The upstream HDR efforts seem to have no interest in supporting scRGB but we *need* that so /shrug
 * We can do it here now! Yipee!
 *
 * Swapchain feedback solves so many problems! :D
 */
static inline void
gamescope_xwayland_swapchain_feedback(struct gamescope_xwayland *gamescope_xwayland, struct wl_surface *surface, uint32_t image_count, uint32_t vk_format, uint32_t vk_colorspace, uint32_t vk_composite_alpha, uint32_t vk_pre_transform, uint32_t vk_present_mode, uint32_t vk_clipped)
{
	wl_proxy_marshal_flags((struct wl_proxy *) gamescope_xwayland,
			 GAMESCOPE_XWAYLAND_SWAPCHAIN_FEEDBACK, NULL, wl_proxy_get_version((struct wl_proxy *) gamescope_xwayland), 0, surface, image_count, vk_format, vk_colorspace, vk_composite_alpha, vk_pre_transform, vk_present_mode, vk_clipped);
}

/**
 * @ingroup iface_gamescope_xwayland
 *
 * Forward HDR metadata from Vulkan to the compositor.
 *
 * HDR Metadata Infoframe as per CTA 861.G spec.
 * This is expected to match exactly with the spec.
 *
 * display_primary_*:
 * Color Primaries of the Data.
 * Specifies X and Y coordinates.
 * These are coded as unsigned 16-bit values in units of
 * 0.00002, where 0x0000 represents zero and 0xC350
 * represents 1.0000.
 *
 * white_point_*:
 * White Point of Colorspace Data.
 * Specifies X and Y coordinates.
 * These are coded as unsigned 16-bit values in units of
 * 0.00002, where 0x0000 represents zero and 0xC350
 * represents 1.0000.
 *
 * max_display_mastering_luminance:
 * Max Mastering Display Luminance.
 * This value is coded as an unsigned 16-bit value in units of 1 cd/m2,
 * where 0x0001 represents 1 cd/m2 and 0xFFFF represents 65535 cd/m2.
 *
 * max_display_mastering_luminance:
 * Min Mastering Display Luminance.
 * This value is coded as an unsigned 16-bit value in units of
 * 0.0001 cd/m2, where 0x0001 represents 0.0001 cd/m2 and 0xFFFF
 * represents 6.5535 cd/m2.
 *
 * max_cll:
 * Max Content Light Level.
 * This value is coded as an unsigned 16-bit value in units of 1 cd/m2,
 * where 0x0001 represents 1 cd/m2 and 0xFFFF represents 65535 cd/m2.
 *
 * max_fall:
 * Max Frame Average Light Level.
 * This value is coded as an unsigned 16-bit value in units of 1 cd/m2,
 * where 0x0001 represents 1 cd/m2 and 0xFFFF represents 65535 cd/m2.
 */
static inline void
gamescope_xwayland_set_hdr_metadata(struct gamescope_xwayland *gamescope_xwayland, struct wl_surface *surface, uint32_t display_primary_red_x, uint32_t display_primary_red_y, uint32_t display_primary_green_x, uint32_t display_primary_green_y, uint32_t display_primary_blue_x, uint32_t display_primary_blue_y, uint32_t white_point_x, uint32_t white_point_y, uint32_t max_display_mastering_luminance, uint32_t min_display_mastering_luminance, uint32_t max_cll, uint32_t max_fall)
{
	wl_proxy_marshal_flags((struct wl_proxy *) gamescope_xwayland,
			 GAMESCOPE_XWAYLAND_SET_HDR_METADATA, NULL, wl_proxy_get_version((struct wl_proxy *) gamescope_xwayland), 0, surface, display_primary_red_x, display_primary_red_y, display_primary_green_x, display_primary_green_y, display_primary_blue_x, display_primary_blue_y, white_point_x, white_point_y, max_display_mastering_luminance, min_display_mastering_luminance, max_cll, max_fall);
}

#ifdef  __cplusplus
}
#endif

#endif
